import { jsxs as c, Fragment as _, jsx as f } from "react/jsx-runtime";
import { useFloating as w, autoUpdate as C, arrow as I, offset as O, flip as S, shift as A, useTransitionStyles as R, useHover as v, useFocus as E, useDismiss as P, useRole as F, useInteractions as L, FloatingPortal as N, FloatingArrow as M } from "@floating-ui/react";
import { useState as U, useRef as j, cloneElement as B } from "react";
import e from "clsx";
/*!
  @versini/ui-tooltip v1.0.2
  © 2025 gizmette.com
*/
try {
  window.__VERSINI_UI_TOOLTIP__ || (window.__VERSINI_UI_TOOLTIP__ = {
    version: "1.0.2",
    buildTime: "01/16/2025 07:57 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const D = "av-tooltip", V = "av-tooltip-arrow", H = () => e("w-max py-1 px-2 rounded text-sm"), W = ({
  mode: t
}) => e({
  "bg-surface-darker": t === "dark" || t === "system",
  "bg-surface-light": t === "light" || t === "alt-system",
  "dark:bg-surface-light": t === "system",
  "dark:bg-surface-darker": t === "alt-system"
}), q = ({
  mode: t
}) => e({
  "text-copy-light": t === "dark" || t === "system",
  "text-copy-dark": t === "light" || t === "alt-system",
  "dark:text-copy-dark": t === "system",
  "dark:text-copy-light": t === "alt-system"
}), z = ({
  mode: t
}) => e({
  "fill-surface-darker [&>path:first-of-type]:bg-surface-darker [&>path:last-of-type]:bg-surface-darker": t === "dark" || t === "system",
  "fill-surface-light [&>path:first-of-type]:bg-surface-light [&>path:last-of-type]:bg-surface-light": t === "light" || t === "alt-system",
  "dark:fill-surface-light dark:[&>path:first-of-type]:bg-surface-light dark:[&>path:last-of-type]:bg-surface-light": t === "system",
  "dark:fill-surface-darker dark:[&>path:first-of-type]:bg-surface-darker dark:[&>path:last-of-type]:bg-surface-darker": t === "alt-system"
}), G = ({
  mode: t
}) => {
  const r = e(
    D,
    H(),
    W({ mode: t }),
    q({ mode: t })
  ), a = e(
    V,
    z({ mode: t })
  );
  return { tooltip: r, arrow: a };
}, Y = ({
  trigger: t,
  label: r,
  placement: a = "top",
  mode: p = "system"
}) => {
  const [o, g] = U(!1), l = j(null), { refs: i, floatingStyles: u, context: s } = w({
    open: o,
    onOpenChange: g,
    placement: a,
    // Make sure the tooltip stays on the screen
    whileElementsMounted: C,
    middleware: [
      I({
        element: l
      }),
      O(10),
      S({
        crossAxis: a.includes("-"),
        fallbackAxisSideDirection: "start"
      }),
      A()
    ]
  }), { styles: y } = R(s), n = G({ mode: p }), h = v(s, { move: !1, delay: { open: 300 } }), d = E(s), k = P(s), m = F(s, { role: "tooltip" }), { getReferenceProps: T, getFloatingProps: b } = L([
    h,
    d,
    k,
    m
  ]), x = B(
    t,
    {
      "aria-label": r,
      "data-open": String(o),
      ref: i.setReference,
      ...T()
    }
  );
  return /* @__PURE__ */ c(_, { children: [
    x,
    /* @__PURE__ */ f(N, { children: o && /* @__PURE__ */ c(
      "div",
      {
        className: n.tooltip,
        ref: i.setFloating,
        style: { ...u, ...y },
        ...b(),
        children: [
          /* @__PURE__ */ f(
            M,
            {
              ref: l,
              context: s,
              className: n.arrow
            }
          ),
          r
        ]
      }
    ) })
  ] });
};
export {
  V as TOOLTIP_ARROW_CLASSNAME,
  D as TOOLTIP_CLASSNAME,
  Y as Tooltip
};
